LeetCode12 Predict the Winner

1、题目描述
Given an array of scores that are non-negative integers. Player 1 picks one of the numbers from either end of the array followed by the player 2 and then player 1 and so on. Each time a player picks a number, that number will not be available for the next player. This continues until all the scores have been chosen. The player with the maximum score wins.
Given an array of scores, predict whether player 1 is the winner. You can assume each player plays to maximize his score.
Example 1:
Input: [1, 5, 2]
Output: False
Explanation: Initially, player 1 can choose between 1 and 2.
If he chooses 2 (or 1), then player 2 can choose from 1 (or 2) and 5. If player 2 chooses 5, then player 1 will be left with 1 (or 2).
So, final score of player 1 is 1 + 2 = 3, and player 2 is 5.
Hence, player 1 will never be the winner and you need to return False.
Example 2:
Input: [1, 5, 233, 7]
Output: True
Explanation: Player 1 first chooses 1. Then player 2 have to choose between 5 and 7. No matter which number player 2 choose, player 1 can choose 233.
Finally, player 1 has more score (234) than player 2 (12), so you need to return True representing player1 can win.
Note:
1 <= length of the array <= 20.
Any scores in the given array are non-negative integers and will not exceed 10,000,000.
If the scores of both players are equal, then player 1 is still the winner.
2、解题思路
题目要求,给出一个非负值数组,玩家1和玩家2只能从数组两端取值,并将该值移出数组,计入各自的总分当中,最后谁的总分高谁就是赢家,如果玩家1赢了,返回ture,否则返回false。
解决这个问题使用动态规划,取值过程中两个玩家的差可以用一个二维数组表示dif,当游戏中剩余元素首尾元素在原数组中对应的下标i和j,可以用dif[i,j]表示此时要取值的玩家总和与另一个玩家的总和之差,然后,这个玩家可能取第i或者j个元素,就会有一个新的子数组生成,此时,会记录dif[i+1,j]或者dif[i,j-1] ,下一个玩家继续从两端取值,动态规划方程是dif[i,j]=max(nums[i]-dif(i+1,j),nums[j]-dif(i,j-1)),dif中的值有些事玩家1-玩家2 的,有些是玩家2-玩家1,这个要具体看子序列是ij时的取值玩家是哪一个,比如序列为0,n-1,时,取值玩家是玩家1,所以dif[0][n-1]就是玩家1总和减去玩家2,最终求得的dif[0][n-1]就是需要的结果,如果它是非负值,结果就返回ture。

3、实现代码

class Solution {
public:
    bool PredictTheWinner(vector<int>& nums) {
        auto n=nums.size();
        vector<vector<int>> dif(n,vector<int> (n));
        for (int i=0;i<n;i++)
            dif[i][i]=nums[i];
        for (int i=1;i<n;i++){
            for (int j=0;i+j<n;j++){
                dif[j][j+1]=max(nums[j]-dif[j+1][j+i],nums[j+i]-dif[j][j+i-1]);
            }
        }
        return dif[0][n-1]>=0;
    }
};
  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 2
    评论
评论 2
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值